<?php

namespace DataFixtures\ORM;

use Doctrine\Bundle\FixturesBundle\Fixture;
use Doctrine\Common\DataFixtures\DependentFixtureInterface;
use Doctrine\Persistence\ObjectManager;
use Doctrine\ORM\Mapping\ClassMetadata;
use Ivoz\Provider\Domain\Model\MatchListPattern\MatchListPattern;

class ProviderMatchListPattern extends Fixture implements DependentFixtureInterface
{
    use \DataFixtures\FixtureHelperTrait;

    /**
     * {@inheritDoc}
     */
    public function load(ObjectManager $manager)
    {
        $fixture = $this;
        $this->disableLifecycleEvents($manager);
        $manager->getClassMetadata(MatchListPattern::class)->setIdGeneratorType(ClassMetadata::GENERATOR_TYPE_NONE);

        $item1 = $this->createEntityInstance(MatchListPattern::class);
        (function () use ($fixture) {
            $this->setDescription("test desc");
            $this->setType("number");
            $this->setNumbervalue("946002050");
            $this->setMatchList($fixture->getReference('_reference_ProviderMatchList1'));
            $this->setNumberCountry($fixture->getReference('_reference_ProviderCountry70'));
        })->call($item1);

        $this->addReference('_reference_ProviderMatchListPatternMatchListPattern1', $item1);
        $this->sanitizeEntityValues($item1);
        $manager->persist($item1);

        $item2 = $this->createEntityInstance(MatchListPattern::class);
        (function () use ($fixture) {
            $this->setDescription("brand test desc");
            $this->setType("number");
            $this->setNumbervalue("946002055");
            $this->setMatchList($fixture->getReference('_reference_ProviderMatchList3'));
            $this->setNumberCountry($fixture->getReference('_reference_ProviderCountry70'));
        })->call($item2);

        $this->addReference('_reference_ProviderMatchListPatternMatchListPattern2', $item2);
        $this->sanitizeEntityValues($item2);
        $manager->persist($item2);

        $manager->flush();
    }

    public function getDependencies()
    {
        return array(
            ProviderMatchList::class,
            ProviderCountry::class,
        );
    }
}
