<?php

namespace Ivoz\Ast\Infrastructure\Persistence\Doctrine;

use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Ivoz\Ast\Domain\Model\PsEndpoint\PsEndpoint;
use Ivoz\Ast\Domain\Model\PsEndpoint\PsEndpointInterface;
use Ivoz\Ast\Domain\Model\PsEndpoint\PsEndpointRepository;
use Doctrine\Persistence\ManagerRegistry;
use Ivoz\Core\Infrastructure\Persistence\Doctrine\Model\Helper\CriteriaHelper;

/**
 * PsEndpointDoctrineRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class PsEndpointDoctrineRepository extends ServiceEntityRepository implements PsEndpointRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, PsEndpoint::class);
    }

    /**
     * @inheritdoc
     * @see PsEndpointRepository::findOneByFriendId
     */
    public function findOneByFriendId($id)
    {
        /** @var PsEndpointInterface $response */
        $response = $this->findOneBy([
            "friend" => $id
        ]);

        return $response;
    }

    /**
     * @inheritdoc
     * @see PsEndpointRepository::findOneByResidentialDeviceId
     */
    public function findOneByResidentialDeviceId($id)
    {
        /** @var PsEndpointInterface $response */
        $response = $this->findOneBy([
            'residentialDevice' => $id
        ]);

        return $response;
    }

    /**
     * @inheritdoc
     * @see PsEndpointRepository::findOneByRetailAccountId
     */
    public function findOneByRetailAccountId($id)
    {
        /** @var PsEndpointInterface $response */
        $response = $this->findOneBy([
            'retailAccount' => $id
        ]);

        return $response;
    }


    /**
     * @inheritdoc
     * @see PsEndpointRepository::findOneByTerminalId
     */
    public function findOneByTerminalId($id)
    {
        /** @var PsEndpointInterface $response */
        $response = $this->findOneBy([
            'terminal' => $id
        ]);

        return $response;
    }

    /**
     * @inheritdoc
     * @see PsEndpointRepository::findOneBySorceryId
     */
    public function findOneBySorceryId($sorceryId)
    {
        /** @var PsEndpointInterface $response */
        $response = $this->findOneBy([
            'sorceryId' => $sorceryId
        ]);

        return $response;
    }

    /**
     * @inheritdoc
     * @return PsEndpointInterface[]
     * @throws \Doctrine\ORM\Query\QueryException
     * @see PsEndpointRepository::getEndpointsWithExtensionOrderByContext
     */
    public function getEndpointsWithExtensionOrderByContext(): array
    {
        $qb = $this->createQueryBuilder('self');

        $qb
            ->select('self')
            ->addCriteria(
                CriteriaHelper::fromArray([
                    'and' => [
                        ['hintExtension', 'neq', ''],
                        ['hintExtension', 'isNotNull'],
                    ],
                ])
            )
            ->orderBy('self.subscribeContext');

        return $qb->getQuery()->getResult();
    }
}
