<?php

namespace Ivoz\Provider\Infrastructure\Persistence\Doctrine;

use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\ORM\QueryBuilder;
use Ivoz\Provider\Domain\Model\CallForwardSetting\CallForwardSetting;
use Ivoz\Provider\Domain\Model\CallForwardSetting\CallForwardSettingInterface;
use Ivoz\Provider\Domain\Model\CallForwardSetting\CallForwardSettingRepository;
use Ivoz\Provider\Domain\Model\User\UserInterface;
use Doctrine\Persistence\ManagerRegistry;

/**
 * CallForwardSettingDoctrineRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 *
 * @template-extends ServiceEntityRepository<CallForwardSetting>
 */
class CallForwardSettingDoctrineRepository extends ServiceEntityRepository implements CallForwardSettingRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, CallForwardSetting::class);
    }

    /**
     * @param mixed $userId
     * @return int
     */
    public function countByUserId($userId): int
    {
        $qb = $this->createQueryBuilder('self');

        return $qb
            ->select('count(self.id)')
            ->where($qb->expr()->eq('self.user', $userId))
            ->getQuery()
            ->getSingleScalarResult();
    }

    /**
     * @return CallForwardSettingInterface[]
     */
    public function findAndJoinByUser(UserInterface $user): array
    {
        $qb = $this->prepareAndJoinByUser($user);
        $query = $qb->getQuery();

        return $query->getResult();
    }

    public function prepareAndJoinByUser(UserInterface $user): QueryBuilder
    {
        $qb = $this->createQueryBuilder('self');

        $response = $qb
            ->select('self', 'e', 'v')
            ->where(
                $qb->expr()->eq('self.user', $user->getId())
            )
            ->leftJoin('self.extension', 'e')
            ->leftJoin('self.voicemail', 'v');

        return $response;
    }
}
