<?php

namespace Ivoz\Provider\Infrastructure\Persistence\Doctrine;

use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Ivoz\Provider\Domain\Model\Country\Country;
use Ivoz\Provider\Domain\Model\Country\CountryInterface;
use Ivoz\Provider\Domain\Model\Country\CountryRepository;
use Doctrine\Persistence\ManagerRegistry;

/**
 * CountryDoctrineRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 *
 * @template-extends ServiceEntityRepository<Country>
 */
class CountryDoctrineRepository extends ServiceEntityRepository implements CountryRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Country::class);
    }

    /**
     * @param string $countryCode
     * @param string|null $code
     * @return CountryInterface|null
     */
    public function findOneByCountryCode(string $countryCode, string $code = null)
    {
        $criteria = [
            'countryCode' => $countryCode,
        ];

        if ($code) {
            $criteria['code'] = $code;
        }

        /** @var CountryInterface | null $response */
        $response = $this->findOneBy($criteria);

        return $response;
    }

    /**
     * @param string $code
     * @return CountryInterface|null
     */
    public function findOneByCode(string $code)
    {
        $criteria = [
            'code' => $code,
        ];

        /** @var CountryInterface | null $response */
        $response = $this->findOneBy($criteria);

        return $response;
    }
}
