<?php

namespace Ivoz\Provider\Infrastructure\Persistence\Doctrine;

use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Ivoz\Provider\Domain\Model\Extension\Extension;
use Ivoz\Provider\Domain\Model\Extension\ExtensionInterface;
use Ivoz\Provider\Domain\Model\Extension\ExtensionRepository;
use Doctrine\Persistence\ManagerRegistry;

/**
 * ExtensionDoctrineRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 *
 * @template-extends ServiceEntityRepository<Extension>
 */
class ExtensionDoctrineRepository extends ServiceEntityRepository implements ExtensionRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Extension::class);
    }

    /**
     * @param int $id
     * @return ExtensionInterface[]
     */
    public function findByCompanyId($id)
    {
        /** @var ExtensionInterface[] $response */
        $response = $this->findBy([
            'company' => $id
        ]);

        return $response;
    }

    /**
     * @return ExtensionInterface | null
     */
    public function findCompanyExtension(int $companyId, string $extensionNumber)
    {
        /** @var ExtensionInterface | null $response */
        $response = $this->findOneBy([
            'company' => $companyId,
            'number' => $extensionNumber
        ]);

        return $response;
    }

    /**
     * @param int[] $includeIds
     * @return ExtensionInterface[]
     */
    public function findUnassignedByCompanyId(int $companyId, array $includeIds = []): array
    {
        $qb = $this->createQueryBuilder('self');
        $expression = $qb->expr();

        $routeConditions = [
            $expression->isNull('self.routeType')
        ];

        if (!empty($includeIds)) {
            $routeConditions[] = $expression->in('self.id', $includeIds);
        }

        $routeCondition = empty($includeIds)
            ? $routeConditions[0]
            : $expression->orX(...$routeConditions);

        $qb
            ->where(
                $expression->eq('self.company', $companyId)
            )
            ->andWhere(
                $routeCondition
            );

        $query = $qb->getQuery();

        return $query->getResult();
    }

    /**
     * @param array<string, mixed> $criteria
     */
    public function count(array $criteria): int
    {
        return parent::count($criteria);
    }
}
