<?php

namespace Ivoz\Provider\Infrastructure\Persistence\Doctrine;

use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Ivoz\Provider\Domain\Model\Administrator\AdministratorInterface;
use Ivoz\Provider\Domain\Model\User\UserInterface;
use Ivoz\Provider\Domain\Model\Voicemail\Voicemail;
use Ivoz\Provider\Domain\Model\Voicemail\VoicemailInterface;
use Ivoz\Provider\Domain\Model\Voicemail\VoicemailRepository;
use Doctrine\Persistence\ManagerRegistry;
use Ivoz\Provider\Domain\Model\VoicemailMessage\VoicemailMessageInterface;

/**
 * VoicemailDoctrineRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 *
 * @template-extends ServiceEntityRepository<Voicemail>
 */
class VoicemailDoctrineRepository extends ServiceEntityRepository implements VoicemailRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Voicemail::class);
    }

    /**
     * @param UserInterface $user
     * @return VoicemailInterface[]
     */
    public function getAvailableVoicemailsForUser(UserInterface $user): array
    {
        $company = $user->getCompany();

        $qb = $this->createQueryBuilder('self');
        $expression = $qb->expr();

        $query = $qb
            ->where(
                $expression->eq('self.company', $company->getid())
            )->andWhere(
                $expression->eq('self.enabled', true)
            )->getQuery();

        return $query->getResult();
    }

    public function getVoicemailsByUser(UserInterface $user): array
    {
        $qb = $this->createQueryBuilder('self');
        $expression = $qb->expr();

        $query = $qb
            ->where(
                $expression->eq('self.id', $user->getId())
            )->getQuery();

        return $query->getResult();
    }

    /**
     * @param UserInterface $user
     * @return array<int|null>
     */
    public function getVoicemailsIdsByUser(UserInterface $user): array
    {
        $voicemails = $this->getVoicemailsByUser($user);

        return array_map(
            function (VoicemailInterface $voicemail) {
                return $voicemail->getId();
            },
            $voicemails
        );
    }

    public function count(array $criteria): int
    {
        return parent::count($criteria);
    }

    public function getGenericVoicemailIds(): array
    {
        $qb = $this->createQueryBuilder('self');
        $expression = $qb->expr();

        $query = $qb
            ->where(
                $expression->isNull('self.user')
            )->getQuery();

        /** @var VoicemailInterface[] $voicemails */
        $voicemails = $query->getResult();

        $result = array_map(
            function (VoicemailInterface $voicemail): int {
                return $voicemail->getId() ?? -1;
            },
            $voicemails
        );

        return $result;
    }
}
