<?php

namespace Ivoz\Provider\Infrastructure\Persistence\Doctrine;

use Doctrine\Persistence\ManagerRegistry;
use Ivoz\Core\Domain\Service\EntityPersisterInterface;
use Ivoz\Core\Infrastructure\Persistence\Doctrine\Repository\DoctrineRepository;
use Ivoz\Provider\Domain\Model\User\UserInterface;
use Ivoz\Provider\Domain\Model\Voicemail\Voicemail;
use Ivoz\Provider\Domain\Model\Voicemail\VoicemailInterface;
use Ivoz\Provider\Domain\Model\VoicemailRelUser\VoicemailRelUser;
use Ivoz\Provider\Domain\Model\VoicemailRelUser\VoicemailRelUserRepository;
use Ivoz\Provider\Domain\Model\VoicemailRelUser\VoicemailRelUserInterface;
use Ivoz\Provider\Domain\Model\VoicemailRelUser\VoicemailRelUserDto;

/**
 * VoicemailRelUserDoctrineRepository
 *
 * This class was generated by ivoz:make:repositories command.
 * Add your own custom repository methods below.
 *
 * @extends DoctrineRepository<VoicemailRelUserInterface, VoicemailRelUserDto>
 */
class VoicemailRelUserDoctrineRepository extends DoctrineRepository implements VoicemailRelUserRepository
{
    public function __construct(
        ManagerRegistry $registry,
        EntityPersisterInterface $entityPersisterInterface,
    ) {
        parent::__construct(
            $registry,
            VoicemailRelUser::class,
            $entityPersisterInterface
        );
    }

    public function remove(\Ivoz\Core\Domain\Model\EntityInterface $voicemailRelUser): void
    {
        parent::remove($voicemailRelUser);
    }

    public function persist(\Ivoz\Core\Domain\Model\EntityInterface $voicemailRelUser, bool $dispatchInmediately = false): void
    {
        parent::persist($voicemailRelUser);
    }

    /**
     * @return int[]
     */
    public function getVoicemailIdsByUser(UserInterface $user): array
    {
        $qb = $this->createQueryBuilder('self');
        $qb->select('IDENTITY(self.voicemail) as voicemailId')
            ->where(
                'self.user = :id'
            )
            ->setParameter(':id', $user->getId());

        $result = $qb->getQuery()->getScalarResult();

        return array_map(
            function ($row): int {
                return (int) $row['voicemailId'];
            },
            $result
        );
    }
}
